# = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
# by Ockham, occam24@aol.com
# 8/25/2013
# For Poser 8 and down, with TKINTER
# = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =

from Tkinter import *
import poser
import os

import math

scene = poser.Scene()
CurObj=scene.CurrentActor()
NearObj=None


# = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
# Next section is TK
# = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =

class App:
    def __init__(self, master, textMessage):
        self.master = master
        master.title("Find Nearest-Set Parent")

        self.StatusEntry = Entry(self.master,width=50)
        self.StatusEntry.grid(row=0,column=0,columnspan=2)

        self.buttonFN = Button(self.master, text="Find Nearest", command=self.FindNearest)
        self.buttonFN.grid(row=3, column=0)

        self.buttonSP = Button(self.master, text="Set Parent", command=self.SetNearest)
        self.buttonSP.grid(row=3, column=1)



    # - - - - - - - - - - - - - - - - - -

    def ShowStatus(self,S): # Just saving repetition
        self.StatusEntry.delete(0,END)
        self.StatusEntry.insert(0,S)
        self.StatusEntry.update_idletasks()

    # - - - - - - - - - - - - - - - - - -

    def Update(self):
        if scene: scene.ProcessSomeEvents()
        root.lift()
        root.after(100, self.Update)


# = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =

    def FindCenter(self,A):
        global NearObj
        try:
                G=A.Geometry()
        except:
                return None,None,None
        if G==None: return None,None,None

        Vcount=G.NumVertices()
        scene.DrawAll()
        MinX= 10000.0
        MinY= 10000.0
        MinZ= 10000.0
        MaxX=-10000.0
        MaxY=-10000.0
        MaxZ=-10000.0
        for V in range(Vcount):
                WV=G.WorldVertex(V)
                X=WV.X()
                Y=WV.Y()
                Z=WV.Z()
                if X>MaxX:MaxX=X
                elif X<MinX:MinX=X
                if Y>MaxY:MaxY=Y
                elif Y<MinY:MinY=Y
                if Z>MaxZ:MaxZ=Z
                elif Z<MinZ:MinZ=Z

        X=(MaxX+MinX)/2.0
        Y=(MaxY+MinY)/2.0
        Z=(MaxZ+MinZ)/2.0
        return X,Y,Z

# = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =

    def FindNearest(self):
        global NearObj

        (x1,y1,z1) = self.FindCenter(CurObj)
        if (x1,y1,z1) == (None,None,None):
            self.ShowStatus('Current actor is bad')

        self.ShowStatus('Working ... this may take some time...')
        NearObj=None
        MinD = 10000.0
        for a in scene.Actors():
            if a.IsBodyPart() or a.IsHairProp():
                (x2,y2,z2)=self.FindCenter(a)
                if (x2,y2,z2) == (None,None,None):
                    continue # skip this one
                dx=x1-x2
                dy=y1-y2
                dz=z1-z2
                d=math.sqrt(dx*dx + dy*dy + dz*dz)
                if d<MinD:
                    MinD=d
                    NearObj=a # at end of loop, last occupant of this var will be nearest obj
        if NearObj==None:
            self.ShowStatus('No nearest part found.')
        else:
            self.ShowStatus('Nearest is %s' % NearObj.Name())



    # - - - - - - - - - - - - - - - - - -

    def SetNearest(self):
        if NearObj==None:
            return
        CurObj.SetParent(NearObj,0,0)
        self.ShowStatus('Parent is set.')


    # - - - - - - - - - - - - - - - - - -
#------------------------------------------------------------
# Activate the loop
#------------------------------------------------------------


root = Tk()
app = App(root, '')
app.Update()
root.mainloop()

#------------------------------------------------------------
# End tk loop.
#-----------------------------------------------------------------------------
# = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =

