# = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
# by Ockham, occam24@aol.com
# 8/25/2013
# For Poser 9 and up, with WX python
# = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =

import wx
import wx.py
import wx.aui

import poser
import math

scene = poser.Scene()
CurObj=scene.CurrentActor()
NearObj=None

# Start wx
man = poser.WxAuiManager()
root = man.GetManagedWindow()


# = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
# Next section is WX
# = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =

class App(wx.Frame):

    # - - - - - - - - - - - - - - - - - -

    def __init__(self,parent,title):
       wx.Frame.__init__(self,parent,title=title,size=(600, 280))

       self.button0 = wx.Button(self,   id=-1, label='Find nearest',   size=(160, 32))
       self.button0.Bind(wx.EVT_BUTTON, self.FindNearest)
       self.button1 = wx.Button(self,   id=-1, label='Set parent',   size=(160, 32))
       self.button1.Bind(wx.EVT_BUTTON, self.SetNearest)

       self.Status = self.CreateStatusBar()
       self.Status.SetStatusText("Hit Find, then if good, hit Set.")

       # Do sizers
       box1 = wx.BoxSizer(wx.HORIZONTAL)
       box1.Add(self.button0,1,wx.ALL,border=5)
       box1.Add(self.button1,1,wx.ALL,border=5)

       mainbox = wx.BoxSizer(wx.VERTICAL)
       mainbox.Add(box1, 1, wx.EXPAND)

       self.SetAutoLayout(True)
       self.SetSizer(mainbox)
       self.Layout()


# = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =

    def FindCenter(self,A):
        global NearObj
        try:
                G=A.Geometry()
        except:
                return None,None,None
        if G==None: return None,None,None

        Vcount=G.NumVertices()
        scene.DrawAll()
        MinX= 10000.0
        MinY= 10000.0
        MinZ= 10000.0
        MaxX=-10000.0
        MaxY=-10000.0
        MaxZ=-10000.0
        for V in range(Vcount):
                WV=G.WorldVertex(V)
                X=WV.X()
                Y=WV.Y()
                Z=WV.Z()
                if X>MaxX:MaxX=X
                elif X<MinX:MinX=X
                if Y>MaxY:MaxY=Y
                elif Y<MinY:MinY=Y
                if Z>MaxZ:MaxZ=Z
                elif Z<MinZ:MinZ=Z

        X=(MaxX+MinX)/2.0
        Y=(MaxY+MinY)/2.0
        Z=(MaxZ+MinZ)/2.0
        return X,Y,Z

# = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =

    def FindNearest(self,event):
        global NearObj

        (x1,y1,z1) = self.FindCenter(CurObj)
        if (x1,y1,z1) == (None,None,None):
            self.Status.SetStatusText('Current actor is bad')

        self.Status.SetStatusText('Working ... this may take some time...')
        NearObj=None
        MinD = 10000.0
        for a in scene.Actors():
            if a.IsBodyPart() or a.IsHairProp():
                (x2,y2,z2)=self.FindCenter(a)
                if (x2,y2,z2) == (None,None,None):
                    continue # skip this one
                dx=x1-x2
                dy=y1-y2
                dz=z1-z2
                d=math.sqrt(dx*dx + dy*dy + dz*dz)
                if d<MinD:
                    MinD=d
                    NearObj=a # at end of loop, last occupant of this var will be nearest obj
        if NearObj==None:
            self.Status.SetStatusText('No nearest part found.')
        else:
            self.Status.SetStatusText('Nearest is %s' % NearObj.Name())



    # - - - - - - - - - - - - - - - - - -

    def SetNearest(self,event):
        if NearObj==None:
            return
        CurObj.SetParent(NearObj,0,0)
        self.Status.SetStatusText('Parent is set.')


    # - - - - - - - - - - - - - - - - - -
#------------------------------------------------------------
# Activate the loop
#------------------------------------------------------------

frame = App(None,title='Find nearest, set parent')
frame.Show()

#------------------------------------------------------------
# End wx loop.
#-----------------------------------------------------------------------------
# = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =

